#<profile4xi profile = "12" />
# -------------------------------------------------------------------------------------------------
#<program4xi program = "constant_synchronize4xi.py">
#<abstract4xi abstract = "Provides the class ConstantSynchronize4Xi"/>
#<refer4xi reference = "syncronize.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------
#

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'constant_synchronize4xi', 'ConstantSynchronize4Xi', 
            'init_all_synchronize4xi', 'set_all_synchronize4xi', 'get_all_synchronize4xi', 
            'init_recursive_mutex_synchronize4xi', 'get_recursive_mutex_synchronize4xi', 'set_recursive_mutex_synchronize4xi', 
            'init_semaphore_synchronize4xi', 'get_semaphore_synchronize4xi', 'set_semaphore_synchronize4xi', 
            'init_sem_value_synchronize4xi', 'get_sem_value_synchronize4xi', 'set_sem_value_synchronize4xi', 
            'init_sem_value_max_synchronize4xi', 'get_sem_value_max_synchronize4xi', 'set_sem_value_max_synchronize4xi']
#"
#/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
try:                 # system ones
    import os
    import sys
    import signal
except:
    pass
try:                 # threading ones       
    import threading                
    import _thread   
except:
    pass
try:
    import _winapi
except:
    pass    
try:                 # most-common ones
    import errno
    import time
    import tempfile
    import itertools         
except:
    pass
try:                 # rare ones
    import socket          
except:
    pass 
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
try:                             # Binary ones
    import _multiprocessing
except:
    pass
#"
#/>
     
# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from ace_object4xi import ace_object4xi
from print4xi import print4xi
from reason_object4xi import reason_object4xi
from sense_object4xi import sense_object4xi
from time4xi import time4xi
#"
#/>

# -------------------------------------------------------------------------------------------------
# Global constants                            
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "
global RECURSIVE_MUTEX
global SEMAPHORE
global SEM_VALUE
global SEM_VALUE_MAX
#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
RECURSIVE_MUTEX, SEMAPHORE = list(range(2))
SEM_VALUE_MAX = _multiprocessing.SemLock.SEM_VALUE_MAX 
SEM_VALUE = 0 
#"
#"/>


# -------------------------------------------------------------------------------------------------
#<function4xi function = "constant-synchronize4xi" usage = "
# defines constants for synchronizing
#"> 
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def constant_synchronize4xi(constant_synchronize4xi):
    '''
    constant_synchronize4xi defines constants for synchronizing

    '''
    global RECURSIVE_MUTEX
    global SEMAPHORE
    global SEM_VALUE
    global SEM_VALUE_MAX   

    class2print = 'constant_synchronize4xi'
    method2print = 'constant_synchronize4xi'
        
    message2print = "{started" + "; constant-synchronize4xi-started: " + str(constant_synchronize4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)               

    message2print = "{passed" + "; constant_synchronize4xi-passed-to-constant-synchronize4xi: " + str(constant_synchronize4xi) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
        
        
    if constant_synchronize4xi == 1:
    
        message2print = "{returning" + "; recursive-mutex-returning-by-constant-synchronize4xi: " + str(RECURSIVE_MUTEX) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)   
        

        return RECURSIVE_MUTEX

    if constant_synchronize4xi == 2:
    
        message2print = "{returning" + "; semaphore-returning-by-constant-synchronize4xi: " + str(SEMAPHORE) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)   
         
        
        return SEMAPHORE        

    if constant_synchronize4xi == 3:
    
        message2print = "{returning" + "; sem-value-returning-by-constant-synchronize4xi: " + str(SEM_VALUE) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)   
          
        
        return SEM_VALUE
    
    if constant_synchronize4xi == 4:
    
        message2print = "{returning" + "; sem-value-max-returning-by-constant-synchronize4xi: " + str(SEM_VALUE_MAX) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)   
          
        
        return SEM_VALUE_MAX


    message2print = "{returning" + "; false-returning-by-constant-synchronize4xi: " + str(False) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)   
         
     
           
    return False        
#</function4xi> 

 
#1#
# -------------------------------------------------------------------------------------------------
#<function4xi function = "init-recursive-mutex-synchronize4xi" usage = "
# initializes RECURSIVE_MUTEX
#"> 
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------    
def init_recursive_mutex_synchronize4xi(init_recursive_mutex_synchronize4xi_param=0):          
    '''
    init_recursive_mutex_synchronize4xi initializes RECURSIVE_MUTEX
    '''
    global RECURSIVE_MUTEX
    
    class2print = 'init_recursive_mutex_synchronize4xi'
    method2print = 'init_recursive_mutex_synchronize4xi'
        
    message2print = "{started" + "; init-recursive-mutex-synchronize4xi-started: " + str(init_recursive_mutex_synchronize4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
        
    message2print = "{passed" + "; init-recursive-mutex-synchronize4xi-param-passed-to-init-recursive-mutex-synchronize4xi: " + str(init_recursive_mutex_synchronize4xi_param) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
        
  
        
    RECURSIVE_MUTEX = init_recursive_mutex_synchronize4xi_param


    message2print = "{initialized" + "; recursive-mutex-initialized-by-init-recursive-mutex-synchronize4xi to: " + str(RECURSIVE_MUTEX)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)             
    
    message2print = "{returning" + "; init-recursive-mutex-synchronize4xi-returning: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)      
                         
#</function4xi> 

          
# -------------------------------------------------------------------------------------------------
#<function4xi function = "set-recursive-mutex-synchronize4xi" usage = "
# sets RECURSIVE_MUTEX
#"> 
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------    
def set_recursive_mutex_synchronize4xi(set_recursive_mutex_synchronize4xi_param=0):          
    '''
    set_recursive_mutex_synchronize4xi sets RECURSIVE_MUTEX
    '''
    global RECURSIVE_MUTEX
    
    class2print = 'set_recursive_mutex_synchronize4xi'
    method2print = 'set_recursive_mutex_synchronize4xi' 
        
    message2print = "{started" + "; set-recursive-mutex-synchronize4xi-started: " + str(set_recursive_mutex_synchronize4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)           
 
    message2print = "{passed" + "; set-recursive-mutex-synchronize4xi-param-passed-to-set-recursive-mutex-synchronize4xi: " + str(set_recursive_mutex_synchronize4xi_param) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
        
              
    RECURSIVE_MUTEX = set_recursive_mutex_synchronize4xi_param    

    message2print = "{set" + "; recursive-mutex-set-by-set-recursive-mutex-synchronize4xi to: " + str(RECURSIVE_MUTEX)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
            
    message2print = "{returning" + "; set-recursive-mutex-synchronize4xi-returning: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)      
                
#</function4xi> 

       
# -------------------------------------------------------------------------------------------------
#<function4xi function = "get-recursive-mutex-synchronize4xi" usage = "
# gets RECURSIVE_MUTEX
#"> 
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------    
def get_recursive_mutex_synchronize4xi():          
    '''
    get_recursive_mutex_synchronize4xi gets RECURSIVE_MUTEX
    '''

    global RECURSIVE_MUTEX
    
    class2print = 'get_recursive_mutex_synchronize4xi'
    method2print = 'get_recursive_mutex_synchronize4xi'
        
    message2print = "{started" + "; get-recursive-mutex-synchronize4xi-started: " + str(get_recursive_mutex_synchronize4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)          
    
    message2print = "{returning" + "; recursive-mutex-returning-by-get-recursive-mutex-synchronize4xi: " + str(RECURSIVE_MUTEX) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)   
        
        
    
    return RECURSIVE_MUTEX            
#</function4xi> 

 
#2#
# -------------------------------------------------------------------------------------------------
#<function4xi function = "init-semaphore-synchronize4xi" usage = "
# initializes SEMAPHORE
#"> 
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------    
def init_semaphore_synchronize4xi(init_semaphore_synchronize4xi_param=1):          
    '''
    init_semaphore_synchronize4xi initializes SEMAPHORE
    '''
    global SEMAPHORE
    
    class2print = 'init_semaphore_synchronize4xi'
    method2print = 'init_semaphore_synchronize4xi'
        
    message2print = "{started" + "; init-semaphore-synchronize4xi-started: " + str(init_semaphore_synchronize4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)             
        
 
      
    SEMAPHORE = init_semaphore_synchronize4xi_param

    message2print = "{initialized" + "; semaphore-initialized-by-init-semaphore-synchronize4xi to: " + str(SEMAPHORE)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)    
    
    message2print = "{returning" + "; init-semaphore-synchronize4xi-returning: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)      
                          
#</function4xi> 

           

# -------------------------------------------------------------------------------------------------
#<function4xi function = "set-semaphore-synchronize4xi" usage = "
# sets SEMAPHORE
#"> 
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------    
def set_semaphore_synchronize4xi(set_semaphore_synchronize4xi_param=1):          
    '''
    set_semaphore_synchronize4xi sets SEMAPHORE
    '''
    global SEMAPHORE
    
    class2print = 'set_semaphore_synchronize4xi'
    method2print = 'set_semaphore_synchronize4xi'
        
    message2print = "{started" + "; set-semaphore-synchronize4xi-started: " + str(set_semaphore_synchronize4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)               
        
    message2print = "{passed" + "; set-semaphore-synchronize4xi-param-passed-to-set-semaphore-synchronize4xi: " + str(set_semaphore_synchronize4xi_param) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
        
       
    SEMAPHORE = set_semaphore_synchronize4xi_param
    
    message2print = "{set" + "; semaphore-set-by-set-semaphore-synchronize4xi to: " + str(SEMAPHORE)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
    
    message2print = "{returning" + "; set-semaphore-synchronize4xi-returning: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)      
                    
#</function4xi> 

           
    
# -------------------------------------------------------------------------------------------------
#<function4xi function = "get-semaphore-synchronize4xi" usage = "
# gets SEMAPHORE
#"> 
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------    
def get_semaphore_synchronize4xi():          
    '''
    get_semaphore_synchronize4xi gets SEMAPHORE
    '''
    global SEMAPHORE
    
    
    class2print = 'get_semaphore_synchronize4xi'
    method2print = 'get_semaphore_synchronize4xi'
        
    message2print = "{started" + "; get-semaphore-synchronize4xi-started: " + str(get_semaphore_synchronize4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)              
    
    message2print = "{returning" + "; semaphore-returning-by-get-semaphore-synchronize4xi: " + str(SEMAPHORE) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)   
        
        
    
    return SEMAPHORE            
#</function4xi> 

     
#3#
# -------------------------------------------------------------------------------------------------
#<function4xi function = "init-sem-value_synchronize4xi" usage = "
# initializes SEM_VALUE
#"> 
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------    
def init_sem_value_synchronize4xi(init_sem_value_synchronize4xi_param=1):          
    '''
    init_sem_value_synchronize4xi initializes SEM_VALUE
    '''
    global SEM_VALUE
    
    class2print = 'init_sem_value_synchronize4xi'
    method2print = 'init_sem_value_synchronize4xi'
        
    message2print = "{started" + "; init-sem-value-synchronize4xi-started: " + str(init_sem_value_synchronize4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)              
        
    message2print = "{passed" + "; init-sem-value-synchronize4xi-param-passed-to-init-sem-value-synchronize4xi: " + str(init_sem_value_synchronize4xi_param) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
          
      
    SEM_VALUE = init_sem_value_synchronize4xi_param

    message2print = "{initialized" + "; sem-value-initialized-by-init-sem-value-synchronize4xi to: " + str(SEM_VALUE)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)    
    
    message2print = "{returning" + "; init-sem-value-synchronize4xi-returning: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)      
                           
#</function4xi> 

           

# -------------------------------------------------------------------------------------------------
#<function4xi function = "set-sem-value_synchronize4xi" usage = "
# sets SEM_VALUE
#"> 
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------    
def set_sem_value_synchronize4xi(set_sem_value_synchronize4xi_param=1):          
    '''
    set_sem_value_synchronize4xi sets SEM_VALUE
    '''
    global SEM_VALUE
    class2print = 'set_sem_value_synchronize4xi'
    method2print = 'set_sem_value_synchronize4xi'
        
    message2print = "{started" + "; set-sem-value-synchronize4xi-started: " + str(set_sem_value_synchronize4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)              
        
    message2print = "{passed" + "; set-sem-value-synchronize4xi-param-passed-to-set-sem-value-synchronize4xi: " + str(set_sem_value_synchronize4xi_param) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
        
       
    SEM_VALUE = set_sem_value_synchronize4xi_param
    
    message2print = "{set" + "; sem-value-set-by-set-sem-value-synchronize4xi to: " + str(SEM_VALUE)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
        
    message2print = "{returning" + "; set-sem-value-synchronize4xi-returning: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)      
                 
#</function4xi> 

       
        
    
# -------------------------------------------------------------------------------------------------
#<function4xi function = "get-sem_value-synchronize4xi" usage = "
# gets SEM_VALUE
#"> 
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------    
def get_sem_value_synchronize4xi():          
    '''
    get_sem_value_synchronize4xi gets SEM_VALUE
    '''
    global SEM_VALUE
    
    class2print = 'get_sem_value_synchronize4xi'
    method2print = 'get_sem_value_synchronize4xi'
        
    message2print = "{started" + "; get-sem_value-synchronize4xi-started: " + str(get_sem_value_synchronize4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)           
    
    message2print = "{returning" + "; sem-value-returning-by-get-sem_value-synchronize4xi: " + str(SEM_VALUE) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)   
        

        
    return SEM_VALUE                
#</function4xi> 

 
#4#
# -------------------------------------------------------------------------------------------------
#<function4xi function = "init-sem-value-max-synchronize4xi" usage = "
# initializes SEM_VALUE_MAX
#"> 
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------    
def init_sem_value_max_synchronize4xi(init_sem_value_max_synchronize4xi_param = _multiprocessing.SemLock.SEM_VALUE_MAX):          
    '''
    init_sem_value_max_synchronize4xi initializes SEM_VALUE_MAX
    '''
    global SEM_VALUE_MAX
    
    class2print = 'init_sem_value_max_synchronize4xi'
    method2print = 'init_sem_value_max_synchronize4xi'
        
    message2print = "{started" + "; init-sem-value-max-synchronize4xi-started: " + str(init_sem_value_max_synchronize4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)     
    
    message2print = "{passed" + "; init-sem-value-max-synchronize4xi-param-passed-to-init-sem-value-max-synchronize4xi: " + str(init_sem_value_max_synchronize4xi_param) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
        
      
    SEM_VALUE_MAX = init_sem_value_max_synchronize4xi_param

    message2print = "{initialized" + "; semvalue-max-initialized-by-init-sem-value-max-synchronize4xi to: " + str(SEM_VALUE_MAX)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)    
    
    message2print = "{returning" + "; init-sem-value-max-synchronize4xi-returning: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)      
                
               
#</function4xi> 

           

# -------------------------------------------------------------------------------------------------
#<function4xi function = "set-sem-value-max-synchronize4xi" usage = "
# sets SEM_VALUE_MAX
#"> 
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------    
def set_sem_value_max_synchronize4xi(set_sem_value_max_synchronize4xi_param = _multiprocessing.SemLock.SEM_VALUE_MAX):          
    '''
    set_sem_value_max_synchronize4xi sets SEM_VALUE_MAX
    '''
    global SEM_VALUE_MAX
    
    class2print = 'set_sem_value_max_synchronize4xi'
    method2print = 'set_sem_value_max_synchronize4xi'
        
    message2print = "{started" + "; set-sem-value-max-synchronize4xi-started: " + str(set_sem_value_max_synchronize4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)         
        
    message2print = "{passed" + "; set-sem-value-max-synchronize4xi_param-passed-to-set-sem-value-max-synchronize4xi: " + str(set_sem_value_max_synchronize4xi_param) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
         
       
    SEM_VALUE_MAX = set_sem_value_max_synchronize4xi_param
    
    message2print = "{set" + "; sem-value-max-set-by-set-sem-value-max-synchronize4xi to: " + str(SEM_VALUE_MAX)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
        
    message2print = "{returning" + "; set-sem-value-max-synchronize4xi-returning: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)      
            
#</function4xi> 

           
    
# -------------------------------------------------------------------------------------------------
#<function4xi function = "get-sem-value-max-synchronize4xi" usage = "
# gets SEM_VALUE_MAX
#"> 
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------    
def get_sem_value_max_synchronize4xi():          
    '''
    get_sem_value_max_synchronize4xi gets SEM_VALUE_MAX
    '''
    global SEM_VALUE_MAX
    

    class2print = 'get_sem_value_max_synchronize4xi'
    method2print = 'get_sem_value_max_synchronize4xi'
        
    message2print = "{started" + "; get-sem-value-max-synchronize4xi-started: " + str(get_sem_value_max_synchronize4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)       
    
    if SEM_VALUE_MAX <= 0:
        init_sem_value_max_synchronize4xi(_multiprocessing.SemLock.SEM_VALUE_MAX)
    
    message2print = "{returning" + "; sem-value-max-returning-by-get-sem-value-max-synchronize4xi: " + str(SEM_VALUE_MAX) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)   
        

    return SEM_VALUE_MAX            
#</function4xi> 

     
#All#
# -------------------------------------------------------------------------------------------------
#<function4xi function = "init-all-synchronize4xi" usage = "
# initializes all synchronize constants
#"> 
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------    
def init_all_synchronize4xi():          
    '''
    init_all_synchronize4xi initializes all synchronize constants
    '''
    
    class2print = 'init_all_synchronize4xi'
    method2print = 'init_all_synchronize4xi'
        
    message2print = "{started" + "; init-all-synchronize4xi-started: " + str(init_all_synchronize4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)           

    
    init_recursive_mutex_synchronize4xi()
    
    init_semaphore_synchronize4xi()
    
    init_sem_value_synchronize4xi()
    
    init_sem_value_max_synchronize4xi()
    
        
    message2print = "{returning" + "; init-all-synchronize4xi-returning: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)      
                 
  
#</function4xi> 

     

# -------------------------------------------------------------------------------------------------
#<function4xi function = "set-all-synchronize4xi" usage = "
# sets all synchronize constants
#"> 
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------    
def set_all_synchronize4xi(set_all_synchronize4xi_param=1):          
    '''
    set_all_synchronize4xi sets all synchronize constants
    '''
    
    class2print = 'set_all_synchronize4xi'
    method2print = 'set_all_synchronize4xi'
        
    message2print = "{started" + "; set-all-synchronize4xi-started: " + str(set_all_synchronize4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)            
        
    message2print = "{passed" + "; set-all-synchronize4xi-param-passed-to-set-all-synchronize4xi: " + str(set_all_synchronize4xi_param) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
        
    
    set_recursive_mutex_synchronize4xi()
    set_semaphore_synchronize4xi()
    set_sem_value_synchronize4xi()
    set_sem_value_max_synchronize4xi()
        
    message2print = "{returning" + "; set-all-synchronize4xi-returning: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)      
                   
#</function4xi> 

     
# -------------------------------------------------------------------------------------------------
#<function4xi function = "get-all-synchronize4xi" usage = "
# gets all synchronize constants
#"> 
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------    
def get_all_synchronize4xi():          
    '''
    get_all_constant_synchronize4xi gets all synchronize constants
    '''
    
    class2print = 'get_all_synchronize4xi'
    method2print = 'get_all_synchronize4xi'
        
    message2print = "{started" + "; get-all-synchronize4xi-started: " + str(get_all_synchronize4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        

        
    # ---------------------------------------------------------------------------------------------
    # could return True after loading an OWL/XML file into memory 
    # ---------------------------------------------------------------------------------------------    

    for i in range(0,5):
        print("constant_synchronize4xi(", i, ") = ", constant_synchronize4xi(i))


    message2print = "{returning" + "; true-returning-by-get-all-synchronize4xi: " + str(True) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)   
        
              
            
    return True
#</function4xi> 

 
#ONE#    
# -------------------------------------------------------------------------------------------------
#<function4xi function = "get-one-constant-synchronize4xi" usage = "
# gets one synchronize constant
#"> 
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------    
def get_one_constant_synchronize4xi(get_one_constant_synchronize4xi_param=3):          
    '''
    get_one_constant_synchronize4xi gets one synchronize constant 
    '''
    class2print = 'get_one_constant_synchronize4xi'
    method2print = 'get_one_constant_synchronize4xi'
        
    message2print = "{started" + "; get-one-constant-synchronize4xi-started: " + str(get_one_constant_synchronize4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)             
        
    message2print = "{passed" + "; get-one-constant-synchronize4xi-param-passed-to-get-one-constant-synchronize4xi: " + str(get_one_constant_synchronize4xi_param) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
        
  
    
    if get_one_constant_synchronize4xi_param <= 0 or get_one_constant_synchronize4xi_param > 4:
        get_one_constant_synchronize4xi_param = 3    
    
    message2print = "{passing" + "; get-one-constant-synchronize4xi-param-passing-to-constant-synchronize4xi: " + str(get_one_constant_synchronize4xi_param) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
        
    message2print = "{returning" + "; constant-synchronize4xi-function-returning-by-get-one-constant-synchronize4xi: " + str(constant_synchronize4xi) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print) 
        
        
    return constant_synchronize4xi(get_one_constant_synchronize4xi_param)            
#</function4xi> 

 
# =================================================================================================
# ConstantSynchronize4Xi class
#<class4xi class = "ConstantSynchronize4Xi" base = "object" child = "None" synopsis = "offers services for process constants" usage = "synchronizing"
#>
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# =================================================================================================
class ConstantSynchronize4Xi(object): #<-- inherits from object class
    '''
    ConstantSynchronize4Xi offers services for process constants
    '''
    # ---------------------------------------------------------------------------------------------
    # Public API of this class
    # ---------------------------------------------------------------------------------------------    
    #<expose4xi expose = "
    _exposed_ = ('init_all', 'set_all', 'get_all', 
                 'init_recursive_mutex', 'get_recursive_mutex', 'set_recursive_mutex', 
                 'init_semaphore', 'get_semaphore', 'set_semaphore', 
                 'init_sem_value', 'get_sem_value', 'set_sem_value', 
                 'init_sem_value_max', 'get_sem_value_max', 'set_sem_value_max', 
                 'sense', 'reason', 'ace')          
    #"
    #/>
                                     
              
    # -------------------------------------------------------------------------------------------------
    #<methodize4xi method = "init-of-ConstantSynchronize4Xi" usage = "initializes synchronize constants">
    #<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
    # -------------------------------------------------------------------------------------------------   
    def __init__(self):
        '''
        _init__ method initializes synchronize constants
        '''       

        class2print = 'ConstantSynchronize4Xi'
        method2print = '__init__'
        
        message2print = "{started" + "; init-of-ConstantSynchronize4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        
        message2print = "{borning" + "; constantsynchronize2xi-of-ConstantSynchronize4Xi-borning: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)     

        message2print = "{inheriting" + "; object-inheriting-by-constantsynchronize2xi-of-ConstantSynchronize4Xi: " + str(object)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
        
     
        init_all_synchronize4xi()        
        
        message2print = "{activated" + "; constantsynchronize2xi-of-ConstantSynchronize4Xi-activated: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                  

        message2print = "{inherited" + "; object-inherited-by-constantsynchronize2xi-of-ConstantSynchronize4Xi: " + str(object)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
          
        message2print = "{returning" + "; init-of-ConstantSynchronize4Xi-returning: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
                        
                
                                  
    #</methodize4xi>
        
    # -------------------------------------------------------------------------------------------------
    #<methodize4xi method = "init-all-of-ConstantSynchronize4Xi" usage = "initializes synchronize constants">
    #<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
    # -------------------------------------------------------------------------------------------------   
    def init_all(self):
        '''
        init_all method initializes synchronize constants
        '''       

        class2print = 'ConstantSynchronize4Xi'
        method2print = 'init_all'
        
        message2print = "{started" + "; init-all-of-ConstantSynchronize4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             


        init_all_synchronize4xi()   
        
        message2print = "{returning" + "; init-all-of-ConstantSynchronize4Xi-returning: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
                        
                
                                 
        
    #</methodize4xi>
    
    # -------------------------------------------------------------------------------------------------
    #<methodize4xi method = "set-all-of-ConstantSynchronize4Xi" usage = "sets all synchronize constants">
    #<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
    # -------------------------------------------------------------------------------------------------   
    def set_all(self):
        '''
        set_all method sets all synchronize constants
        '''       

        class2print = 'ConstantSynchronize4Xi'
        method2print = 'set_all'
        
        message2print = "{started" + "; set-all-of-ConstantSynchronize4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                    


        set_all_synchronize4xi()             
        
        message2print = "{returning" + "; set-all-of-ConstantSynchronize4Xi-returning: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
                        
                
                                  
    #</methodize4xi>
    
    # -------------------------------------------------------------------------------------------------
    #<methodize4xi method = "get-all-of-ConstantSynchronize4Xi" usage = "gets all synchronize constants">
    #<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
    # -------------------------------------------------------------------------------------------------   
    def get_all(self):
        '''
        get_all method gets all synchronize constants
        '''       

        class2print = 'ConstantSynchronize4Xi'
        method2print = 'get_all'
        
        message2print = "{started" + "; get-all-of-ConstantSynchronize4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                    

        message2print = "{returning" + "; get-all-synchronize4xi-function-returning-by-get-all-of-ConstantSynchronize4Xi: " + str(get_all_synchronize4xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)  
                  

        return get_all_synchronize4xi()    
    #</methodize4xi>
    
    #One
    # -------------------------------------------------------------------------------------------------
    #<methodize4xi method = "get-one-of-ConstantSynchronize4Xi" usage = "gets all synchronize constants">
    #<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
    # -------------------------------------------------------------------------------------------------   
    def get_one(self, get_one_param):
        '''
        get_one method gets all synchronize constants
        '''       

        class2print = 'ConstantSynchronize4Xi'
        method2print = 'get_one'
        
        message2print = "{started" + "; get-one-of-ConstantSynchronize4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                    
        
        message2print = "{passed" + "; get-one-param-passed-to-get-one-of-ConstantSynchronize4Xi: " + str(get_one_param) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
        
        message2print = "{passing" + "; get-one-param-passing-to-get-one-synchronize4xi-by-get-one-of-ConstantSynchronize4Xi: " + str(get_one_param) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
                
        message2print = "{returning" + "; get-one-synchronize4xi-function-returning-by-get-one-of-ConstantSynchronize4Xi: " + str(get_one_synchronize4xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)  
                                
                
        return get_one_synchronize4xi(get_one_param)          
    #</methodize4xi>
        
    #1#
    # -------------------------------------------------------------------------------------------------
    #<methodize4xi method = "init-recursive-mutex-of-ConstantSynchronize4Xi" usage = "initializes RECURSIVE_MUTEX">
    #<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
    # -------------------------------------------------------------------------------------------------    
    def init_recursive_mutex(self,init_recursive_mutex_param):          
        '''
        init_recursive_mutex initializes RECURSIVE_MUTEX
        '''

        class2print = 'ConstantSynchronize4Xi'
        method2print = 'init_recursive_mutex'
        
        message2print = "{started" + "; init-recursive-mutex-of-ConstantSynchronize4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                    
        
        message2print = "{passing" + "; init-recursive-mutex-param-passing-to-init-recursive-mutex-synchronize4xi-by-init-recursive-mutex-of-ConstantSynchronize4Xi: " + str(init_recursive_mutex_param) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
                
        init_recursive_mutex_synchronize4xi(init_recursive_mutex_param)
    
        
        message2print = "{returning" + "; init-recursive-mutex-of-ConstantSynchronize4Xi-returning: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
                        
                
                                   
    #</methodize4xi>
        
    # -------------------------------------------------------------------------------------------------
    #<methodize4xi method = "set-recursive-mutex-of-ConstantSynchronize4Xi" usage = "sets RECURSIVE_MUTEX">
    #<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
    # -------------------------------------------------------------------------------------------------    
    def set_recursive_mutex(self,set_recursive_mutex_param):          
        '''
        set_recursive_mutex sets RECURSIVE_MUTEX
        '''
            

        class2print = 'ConstantSynchronize4Xi'
        method2print = 'set_recursive_mutex'
        
        message2print = "{started" + "; set-recursive-mutex-of-ConstantSynchronize4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                    
        
        message2print = "{passing" + "; set-recursive-mutex-param-passing-to-set-recursive-mutex-synchronize4xi-by-set-recursive-mutex-of-ConstantSynchronize4Xi: " + str(set_recursive_mutex_param) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
                
                

        set_recursive_mutex_synchronize4xi(set_recursive_mutex_param)
        
        message2print = "{returning" + "; set-recursive-mutex-of-ConstantSynchronize4Xi-returning: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
                        
                
                                   
    #</methodize4xi>
            
    # -------------------------------------------------------------------------------------------------
    #<methodize4xi method = "get-recursive-mutex-of-ConstantSynchronize4Xi" usage = "gets RECURSIVE_MUTEX">
    #<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
    # -------------------------------------------------------------------------------------------------    
    def get_recursive_mutex(self):          
        '''
        get_recursive_mutex gets RECURSIVE_MUTEX
        '''
        

        class2print = 'ConstantSynchronize4Xi'
        method2print = 'get-recursive-mutex'
        
        message2print = "{started" + "; get-recursive-mutex-of-ConstantSynchronize4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                    

        message2print = "{returning" + "; get-recursive-mutex-synchronize4xi-function-returning-by-get-recursive-mutex-of-ConstantSynchronize4Xi: " + str(get_recursive_mutex_synchronize4xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)  
                
                
        return get_recursive_mutex_synchronize4xi()            
    #</methodize4xi>
        
    #2#
    # -------------------------------------------------------------------------------------------------
    #<methodize4xi method = "init-semaphore-of-ConstantSynchronize4Xi" usage = "initializes SEMAPHORE">
    #<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
    # -------------------------------------------------------------------------------------------------    
    def init_semaphore(self,init_semaphore_param):          
        '''
        init_semaphore initializes SEMAPHORE
        '''

        class2print = 'ConstantSynchronize4Xi'
        method2print = 'init_semaphore'
        
        message2print = "{started" + "; init-semaphore-of-ConstantSynchronize4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                    
        
        message2print = "{passing" + "; init-semaphore-param-passing-to-init-semaphore-synchronize4xi-by-init-semaphore-of-ConstantSynchronize4Xi: " + str(init_semaphore_param) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            

        init_semaphore_synchronize4xi(init_semaphore_param)
        
        message2print = "{returning" + "; init-semaphore-of-ConstantSynchronize4Xi-returning: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
                        
                
                                  
    
    #</methodize4xi>
        
    # -------------------------------------------------------------------------------------------------
    #<methodize4xi method = "set-semaphore-of-ConstantSynchronize4Xi" usage = "sets SEMAPHORE">
    #<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
    # -------------------------------------------------------------------------------------------------    
    def set_semaphore(self,set_semaphore_param):          
        '''
        set_semaphore sets SEMAPHORE
        '''

        class2print = 'ConstantSynchronize4Xi'
        method2print = 'set_semaphore'
        
        message2print = "{started" + "; set-semaphore-of-ConstantSynchronize4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                    
        
        message2print = "{passing" + "; set-semaphore-param-passing-to-set-semaphore-synchronize4xi-by-set-semaphore-of-ConstantSynchronize4Xi: " + str(set_semaphore_param) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
                
                

        set_semaphore_synchronize4xi(set_semaphore_param)
        
        
        message2print = "{returning" + "; set-semaphore-of-ConstantSynchronize4Xi-returning: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
                        
                
                                    
    #</methodize4xi>
            
    # -------------------------------------------------------------------------------------------------
    #<methodize4xi method = "get-semaphore-of-ConstantSynchronize4Xi" usage = "gets SEMAPHORE">
    #<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
    # -------------------------------------------------------------------------------------------------    
    def get_semaphore(self):          
        '''
        get_semaphore gets SEMAPHORE
        '''

        class2print = 'ConstantSynchronize4Xi'
        method2print = 'get_semaphore'
        
        message2print = "{started" + "; get-semaphore-of-ConstantSynchronize4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                    
        
        message2print = "{returning" + "; get-semaphore-synchronize4xi-function-returning-by-get-semaphore-of-ConstantSynchronize4Xi: " + str(get_semaphore_synchronize4xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)  
                
                
        return get_semaphore_synchronize4xi()           
    #</methodize4xi>
            
    #3#
    # -------------------------------------------------------------------------------------------------
    #<methodize4xi method = "init-sem-value-of-ConstantSynchronize4Xi" usage = "initializes SEM_VALUE">
    #<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
    # -------------------------------------------------------------------------------------------------    
    def init_sem_value(self,init_sem_value_param):          
        '''
        init_sem_value initializes SEM_VALUE
        '''

        class2print = 'ConstantSynchronize4Xi'
        method2print = 'init_sem_value'
        
        message2print = "{started" + "; init-sem-value-of-ConstantSynchronize4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                    
        
        message2print = "{passing" + "; init-sem-value-param-passing-to-init-sem-value-synchronize4xi-by-init-sem-value-of-ConstantSynchronize4Xi: " + str(init_sem_value_param) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
                

        init_sem_value_synchronize4xi(init_sem_value_param)
        
        message2print = "{returning" + "; init-sem-value-of-ConstantSynchronize4Xi-returning: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
                        
                
                                  
    
    #</methodize4xi>
    
    # -------------------------------------------------------------------------------------------------
    #<methodize4xi method = "set-sem-value-of-ConstantSynchronize4Xi" usage = "sets SEM_VALUE">
    #<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
    # -------------------------------------------------------------------------------------------------    
    def set_sem_value(self,set_sem_value_param):          
        '''
        set_sem_value sets SEM_VALUE
        '''

        class2print = 'ConstantSynchronize4Xi'
        method2print = 'set_sem_value'
        
        message2print = "{started" + "; set-sem-value-of-ConstantSynchronize4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                    
        
        message2print = "{passing" + "; set-sem-value-param-passing-to-set-sem-value-synchronize4xi-by-set-sem-value-of-ConstantSynchronize4Xi: " + str(set_sem_value_param) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
                
                
        set_sem_value_synchronize4xi(set_sem_value_param)
        
        message2print = "{returning" + "; set-sem-value-of-ConstantSynchronize4Xi-returning: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        

                   
    #</methodize4xi>
            
    # -------------------------------------------------------------------------------------------------
    #<methodize4xi method = "get-sem-value-of-ConstantSynchronize4Xi" usage = "gets SEM_VALUE">
    #<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
    # -------------------------------------------------------------------------------------------------    
    def get_sem_value(self):          
        '''
        get_sem_value gets SEM_VALUE
        '''
        

        class2print = 'ConstantSynchronize4Xi'
        method2print = 'get_sem_value'
        
        message2print = "{started" + "; get-sem-value-of-ConstantSynchronize4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                    

             
        message2print = "{returning" + "; get-sem-value-synchronize4xi-function-returning-by-get-sem-value-of-ConstantSynchronize4Xi: " + str(get_sem_value_synchronize4xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)  
                
        return get_sem_value_synchronize4xi()                  
    #</methodize4xi>
    
    #4#
    # -------------------------------------------------------------------------------------------------
    #<methodize4xi method = "init-sem-value-of-ConstantSynchronize4Xi" usage = "initializes SEM_VALUE_MAX">
    #<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
    # -------------------------------------------------------------------------------------------------    
    def init_sem_value(self,init_sem_value_param):          
        '''
        init_sem_value initializes SEM_VALUE_MAX
        '''

        class2print = 'ConstantSynchronize4Xi'
        method2print = 'init_sem_value'
        
        message2print = "{started" + "; init-sem-value-of-ConstantSynchronize4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                    
        
        message2print = "{passing" + "; init-sem-value-param-passing-to-init-sem-value-max-synchronize4xi-by-init-sem-value-of-ConstantSynchronize4Xi: " + str(init_sem_value_param) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
                
                    
    
        init_sem_value_max_synchronize4xi(init_sem_value_param)
    
        message2print = "{returning" + "; init-sem-value-of-ConstantSynchronize4Xi-returning: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        

           
    #</methodize4xi>
    
    # -------------------------------------------------------------------------------------------------
    #<methodize4xi method = "set-sem-value-max-of-ConstantSynchronize4Xi" usage = "sets SEM_VALUE_MAX">
    #<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
    # -------------------------------------------------------------------------------------------------    
    def set_sem_value_max(self,set_sem_value_max_param):          
        '''
        set_sem_value_max sets SEM_VALUE_MAX
        '''

        class2print = 'ConstantSynchronize4Xi'
        method2print = 'set_sem_value_max'
        
        message2print = "{started" + "; set-sem-value-max-of-ConstantSynchronize4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                    
        
        message2print = "{passing" + "; set-sem-value-max-param-passing-to-set-sem-value-max-synchronize4xi-by-set-sem-value-max-of-ConstantSynchronize4Xi: " + str(set_sem_value_max_param) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
                
                

        set_sem_value_max_synchronize4xi(set_sem_value_max_param)
        
        message2print = "{returning" + "; set-sem-value-max-of-ConstantSynchronize4Xi-returning: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        

            
    #</methodize4xi>
            
    # -------------------------------------------------------------------------------------------------
    #<methodize4xi method = "get-sem-value-max-of-ConstantSynchronize4Xi" usage = "gets SEM_VALUE_MAX">
    #<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
    # -------------------------------------------------------------------------------------------------    
    def get_sem_value_max(self):          
        '''
        get_sem_value gets SEM_VALUE_MAX
        '''
        

        class2print = 'ConstantSynchronize4Xi'
        method2print = 'get_sem_value_max'
        
        
        message2print = "{started" + "; get-sem-value-max-of-ConstantSynchronize4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                    

        message2print = "{returning" + "; get-sem-value-max-synchronize4xi-function-returning-by-get-sem-value-max-of-ConstantSynchronize4Xi: " + str(get_sem_value_max_synchronize4xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)  
                 
        return get_sem_value_max_synchronize4xi()           
    #</methodize4xi>
                                           
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "sense-of-ConstantSynchronize4Xi" usage = "senses class objects">
    #<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def sense(self):
        '''
        senses ConstantSynchronize4Xi class objects
        '''
          
        
        class2print = 'ConstantSynchronize4Xi'
        method2print = 'sense'
        
        message2print = "{started" + "; sense-of-ConstantSynchronize4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)          
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------  
        message2print = "{sensing" + "; constant_synchronize4xi-sensing-by-sense-of-ConstantSynchronize4Xi: " + str(ConstantSynchronize4Xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
                      
        
        # -----------------------------------------------------------------------------------------
        # get sensed knowledge for this object
        # -----------------------------------------------------------------------------------------        
        kb2xi = sense_object4xi(self)
        
        message2print = "{got" + "; kb2xi-got-by-sense-of-ConstantSynchronize4Xi: " + str(kb2xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
                
        
        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # -----------------------------------------------------------------------------------------         
        try:
            kb2xi['inheritance-of-constantsynchronize2xi'] = object
        except:
            message2print = "{yielded" + "; kb2xi-yielded-by-sense-of-ConstantSynchronize4Xi: " + str(kb2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
        
        
      
        message2print = "{sensed" + "; constant_synchronize4xi-sensed-by-sense-of-ConstantSynchronize4Xi: " + str(ConstantSynchronize4Xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        
        # -----------------------------------------------------------------------------------------
        # 
        # -----------------------------------------------------------------------------------------         
        message2print = "{returning" + "; kb2xi-returning-by-sense-of-ConstantSynchronize4Xi: " + str(kb2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)    
                             
          
        return kb2xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
    #</methodize4xi>
    
        
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "reason-of-ConstantSynchronize4Xi" usage = "reasons class objects">
    #<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def reason(self):
        '''
        reasons ConstantSynchronize4Xi class objects
        '''
                 
        
        class2print = 'ConstantSynchronize4Xi'
        method2print = 'reason'

        message2print = "{started" + "; reason-of-ConstantSynchronize4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                  
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------
        message2print = "{reasoning" + "; constant_synchronize4xi-reasoning-by-reason-of-ConstantSynchronize4Xi: " + str(ConstantSynchronize4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
                
        
        # -----------------------------------------------------------------------------------------
        # get reasoned knowledge for this object
        # -----------------------------------------------------------------------------------------         
        kb4xi = reason_object4xi(self)
        

        message2print = "{got" + "; kb4xi-got-by-reason-of-ConstantSynchronize4Xi: " + str(kb4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
                        
        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb4xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------          
        
        message2print = "{reasoned" + "; constant_synchronize4xi-reasoned-by-reason-of-ConstantSynchronize4Xi: " + str(ConstantSynchronize4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
    
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
        message2print = "{returning" + "; kb4xi-returning-by-reason-of-ConstantSynchronize4Xi: " + str(kb4xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)    
                                   
          
        return kb4xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------            
    #</methodize4xi>
    
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "ace-of-ConstantSynchronize4Xi" usage = "aces class objects">
    #<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def ace(self):
        '''
        aces ConstantSynchronize4Xi class objects 
        '''
               
        
        
        class2print = 'ConstantSynchronize4Xi'
        method2print = 'ace'
        
        message2print = "{started" + "; ace-of-ConstantSynchronize4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                       
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------
        message2print = "{acing" + "; constant_synchronize4xi-acing-by-ace-of-ConstantSynchronize4Xi: " + str(ConstantSynchronize4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
                 
        
        # -----------------------------------------------------------------------------------------
        # get aced knowledge for this object
        # -----------------------------------------------------------------------------------------        
        kb8xi = ace_object4xi(self)  
        

        message2print = "{got" + "; kb8xi-got-by-ace-of-ConstantSynchronize4Xi: " + str(kb8xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
                

        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb8xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------              
        
          
        message2print = "{aced" + "; constant_synchronize4xi-aced-by-ace-of-ConstantSynchronize4Xi: " + str(ConstantSynchronize4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
         
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
        message2print = "{returning" + "; kb8xi-returning-by-ace-of-ConstantSynchronize4Xi: " + str(kb8xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)           
        
        return kb8xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------            
    #</methodize4xi>
#</class4xi>
#</program4xi>

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_constant_synchronize4xi.txt
#   sense-test-constant-synchronize4xi.xml
#   reason-test-constant-synchronize4xi.xml
#   ace-test-constant-synchronize4xi.xml
#"
#>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of constant_synchronize4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>

